<?php
/*
 *  Income module for MyPlaza - allows people to actually earn stuff :P
 *
 *  Note, this module requires two code modifications (well, unless you don't want them)
 *  
 *  In /inc/class_moderation.php:
 *  --- Find ---
function delete_post($pid)
{
	global $db, $cache, $plugins;
 *   -- Replace with --
function delete_post($pid)
	{
		global $db, $cache, $plugins, $post;
 *
 *  --- Find ---
function delete_thread($pid)
	{
		global $db, $cache, $plugins;
 *   -- Replace with
function delete_thread($pid)
	{
		global $db, $cache, $plugins, $thread, $userposts;
 *
 */


if(!defined("IN_MYBB"))
	die("This file cannot be accessed directly.");

function income_lang_admin()
{
	global $mybb, $l;
	switch($mybb->settings['bblanguage'])
	{
		default:
			$l['income_title'] = 'Income Module';
			$l['income_description'] = 'Allows members to earn income from posts, threads etc';
			
			$l['income_money_post'] = 'Money Per Post';
			$l['income_money_post_desc'] = 'Amount of money given to users for making a post.';
			$l['income_money_postedit'] = 'Money Per Post Edit';
			$l['income_money_postedit_desc'] = 'Amount of money given to users for editing a post (note, if a moderator edits a post, he/she will get money too!).';
			$l['income_money_reply'] = 'Money Per Reply';
			$l['income_money_reply_desc'] = 'Amount of money given to the topic creator for a reply to their topic.';
			$l['income_money_thread'] = 'Money Per Thread';
			$l['income_money_thread_desc'] = 'Amount of money given to users for making a new thread.';
			$l['income_money_poll'] = 'Money Per Poll';
			$l['income_money_poll_desc'] = 'Amount of money given to users for making a new poll.';
			$l['income_money_pollvote'] = 'Money Per Poll Vote';
			$l['income_money_pollvote_desc'] = 'Amount of money given to users for voting in a poll.';
			$l['income_money_pollparticipate'] = 'Money Per Vote to Poll Creator';
			$l['income_money_pollparticipate_desc'] = 'Amount of money given to the poll creator per vote.';
			$l['income_money_referral'] = 'Money Per Referral';
			$l['income_money_referral_desc'] = 'Amount of money given to a user for referring another user to signup (requires referrals to be enabled).';
			$l['income_money_referredbonus'] = 'Referral Bonus Money';
			$l['income_money_referredbonus_desc'] = 'Amount of bonus money given to new users who claim to have been referred by another member (requires referrals to be enabled).';
			$l['income_money_ratethread'] = 'Money Per Thread Rated';
			$l['income_money_ratethread_desc'] = 'Amount of money given to a user for rating a thread.';
			$l['income_money_ratethread_base'] = 'Value of Thread';
			$l['income_money_ratethread_base_desc'] = 'Amount of money given to a topic creator for a thread rating.  Note that this is a _base_ value - the amount of money given to the topic creator = _base_ * (rating/3)';
			$l['income_money_rateuser'] = 'Money Per User Rated';
			$l['income_money_rateuser_desc'] = 'Amount of money given to a user for rating another user.';
			$l['income_money_rateuser_base'] = 'Value of Reputation';
			$l['income_money_rateuser_base_desc'] = 'Amount of money given to a user for being rated.  Note that this is a _base_ value - the amount of money given to the user = _base_ * rating';
			$l['income_money_pmsend'] = 'Money Per PM Sent';
			$l['income_money_pmsend_desc'] = 'Amount of money given to a user for sending a Private Message.';
			$l['income_money_pmview'] = 'Money Per PM Viewed';
			$l['income_money_pmview_desc'] = 'Amount of money given to a user for reading a (unread) Private Message.';
			$l['income_money_attach'] = 'Money Per Attachment';
			$l['income_money_attach_desc'] = 'Amount of money given to a user for attaching a file.';
			$l['income_money_page'] = 'Money Per Page Viewed';
			$l['income_money_page_desc'] = 'Amount of money given to a user for viewing a page on the forum.';
			$l['income_money_thread_open'] = 'Value of Opened Thread';
			$l['income_money_thread_open_desc'] = 'Amount of money given to a user if their thread is opened by a moderator.  Note, closing a thread will take this amount away.';
			$l['income_money_thread_stick'] = 'Value of Stuck Thread';
			$l['income_money_thread_stick_desc'] = 'Amount of money given to a user if their thread is stuck by a moderator.  Note, unsticking a thread will take this amount away.';
			$l['income_global_rate_income'] = 'Income Rate';
			$l['income_global_rate_income_desc'] = 'All income is multiplied by this number.  This should usually be set to 1.';
			$l['income_global_rate_income_negate'] = 'Negate Rate';
			$l['income_global_rate_income_negate_desc'] = 'Negative income (ie deleting a post) is multiplied by this number.  Note that this number is affected by the above option as well.';
			
			$l['income_rate'] = 'Income rate';
			$l['income_amount'] = 'Income amount';
			$l['income_posting_active'] = 'Posting (active)';
			$l['income_posting_passive'] = 'Posting (passive)';
			$l['income_user_rating'] = 'Users and ratings';
			$l['income_moderation'] = 'Moderation';
			$l['income_misc'] = 'Miscellaneous';
	}
}

function income_info()
{
	global $lang;
	return array(
		"name"			=> $lang->income_title,
		"description"	=> $lang->income_description,
		"website"		=> "http://zingaburga.com/",
		"author"		=> "ZiNgA BuRgA",
		"authorsite"	=> "http://zingaburga.com/",
		"version"		=> "1.0",
	);
}

function income_plugin()
{
	global $plugins;
	// for adding money
	$plugins->add_hook('datahandler_user_insert', 'myplaza_register');

	$plugins->add_hook('datahandler_post_insert_post', 'myplaza_post_new');
	$plugins->add_hook('datahandler_post_update', 'myplaza_post_edit');
	$plugins->add_hook('class_moderation_delete_post', 'myplaza_post_delete');
	$plugins->add_hook('datahandler_post_insert_thread', 'myplaza_thread_new');
	$plugins->add_hook('class_moderation_delete_thread', 'myplaza_thread_delete');
	$plugins->add_hook('polls_do_newpoll_process', 'myplaza_poll_new');
	$plugins->add_hook('class_moderation_delete_poll', 'myplaza_poll_delete');
	$plugins->add_hook('polls_vote_process', 'myplaza_pollvote');
	$plugins->add_hook('upload_attachment_do_insert', 'myplaza_attach_new');
	$plugins->add_hook('remove_attachment_do_delete', 'myplaza_attach_delete');
	$plugins->add_hook('remove_attachments_do_delete', 'myplaza_attach_delete');
	$plugins->add_hook('ratethread_process', 'myplaza_ratethread');
	$plugins->add_hook('reputation_do_add_process', 'myplaza_rateuser');
	$plugins->add_hook('private_do_send_end', 'myplaza_pmsend');
	$plugins->add_hook('private_read_end', 'myplaza_pmview');
	$plugins->add_hook('global_end', 'myplaza_viewpage');

	// moderation stuff
	$plugins->add_hook('class_moderation_open_threads', 'myplaza_threads_open');
	$plugins->add_hook('class_moderation_close_threads', 'myplaza_threads_close');
	$plugins->add_hook('class_moderation_stick_threads', 'myplaza_threads_stick');
	$plugins->add_hook('class_moderation_unstick_threads', 'myplaza_threads_unstick');
}

function income_activate()
{
	global $db, $lang;
	
	$new_settings = income_settings();
	
	$counter = 1;
	foreach($new_settings as $setting => $value)
	{
		$desc_lang = $setting.'_desc';
		$db->insert_query(TABLE_PREFIX."settings", array(
			"name" => $setting,
			"title" => $lang->$setting,
			"description" => $lang->$desc_lang,
			"optionscode" => 'text',
			"value" => $value,
			"disporder" => $counter++,
			"gid" => 0,
		));
	}
	
	rebuildsettings();
}

function income_deactivate()
{
	global $db;
	$temp_settings = array_keys(income_settings());
	for($i=0; $i<count($temp_settings); $i++)
		$temp_settings[$i] = '"'.$temp_settings[$i].'"';
	$db->delete_query(TABLE_PREFIX.'settings', 'name IN ('.implode(',',$temp_settings).')');
	
	rebuildsettings();
}


// I guess this could be used to show income rates
/*function income_page()
{
	error('Nothing to do... :|');
}*/


function income_admin($processing)
{
	$income_settings = array_keys(income_settings());
	if($processing)
	{
		myplaza_process_settings($income_settings);
	}
	else
	{
		global $lang;
		cpheader_myplaza_module();
		starttable();
		tableheader($lang->income_rate, "", 2);
		myplaza_generate_settings_code(array('income_global_rate_income', 'income_global_rate_income_negate'));
		endtable();
		
		echo '<br />';
		starttable();
		tableheader($lang->income_amount, "", 2);
		tablesubheader($lang->income_posting_active, '', 2);
		myplaza_generate_settings_code(array('income_money_post', 'income_money_postedit', 'income_money_thread', 'income_money_poll', 'income_money_pollvote', 'income_money_pmsend', 'income_money_attach'));
		tablesubheader($lang->income_posting_passive, '', 2);
		myplaza_generate_settings_code(array('income_money_reply', 'income_money_pollparticipate', ));
		
		tablesubheader($lang->income_moderation, '', 2);
		myplaza_generate_settings_code(array('income_money_thread_open', 'income_money_thread_stick', ));

		tablesubheader($lang->income_user_rating, '', 2);
		myplaza_generate_settings_code(array('income_money_referral', 'income_money_referredbonus', 'income_money_ratethread', 'income_money_ratethread_base', 'income_money_rateuser', 'income_money_rateuser_base'));
		
		tablesubheader($lang->income_misc, '', 2);
		myplaza_generate_settings_code(array('income_money_pmview', 'income_money_page', ));
		
		endtable();
		
		cpfooter_myplaza_module();
	}
}



//////////
// Functions to add money
/////////

function myplaza_register($uh) {
	if($refuid = intval($uh->data['referrer_uid']))
	{
		add_money('referral', false, $refuid);
		//give money to the current user too :P
		add_money('referredbonus', false);
	}
}

function myplaza_post_new()			{ add_money('post', false); }
function myplaza_post_edit()		{ add_money('postedit', false); } // hehe, if mod edits, he gets money :P
function myplaza_post_delete() {
	global $post;
	if(isset($post['uid']))
		add_money('post', true, $post['uid']);
}

function myplaza_thread_new()		{ add_money('thread', false); add_money('post', false); }
function myplaza_thread_delete() {
	global $thread, $userposts;
	if(isset($thread['uid']) && isset($userposts) && is_array($userposts))
	{
		add_money('thread', true, $thread['uid']);
		// if this deletes a poll, remove money from the poll
		if($thread['poll'])
			add_money('poll', true, $thread['uid']);
		// remove money gained from posts
		foreach($userposts as $uid => $subtract)
		{
			add_money('post', true, $uid, -$subtract);
		}
	}
}

function myplaza_pollvote()			{ add_money('pollvote', false); }

function myplaza_poll_new()			{ add_money('poll', false); }
function myplaza_poll_delete($pid) {
	global $db;
	$uid = $db->fetch_field($db->simple_select(TABLE_PREFIX.'threads', 'uid', 'poll='.$pid), 'uid');
	add_money('poll', true, $uid);
}

function myplaza_attach_new($a)		{ add_money('attach', false, $a['uid']); }
function myplaza_attach_delete($a)	{ add_money('attach', true, $a['uid']); }

function myplaza_viewpage()			{ add_money('page', false); }

function myplaza_ratethread() {
	add_money('ratethread', false);
	
	global $mybb;
	if($rating = intval($mybb->input['rating']))
		if($thread = get_thread(intval($mybb->input['tid'])))
			if($thread['uid'])
				add_money('ratethread_base', false, $thread['uid'], $rating-3);
}
function myplaza_rateuser() {
	add_money('rateuser', false);
	
	global $mybb;
	if($uid = intval($mybb->input['uid']))
		if($rep = intval($mybb->input['reputation']))
			add_money('rateuser_base', false, $uid, $rep);
}


// make sure PM is not sent to self
function myplaza_pmsend() {
	global $pmhandler, $mybb;
	if($mybb->user['uid'] != $pmhandler->data['toid']) add_money('pmsend', false);
}
// make sure PM is not already read
function myplaza_pmview() {
	if($pm['status'] == "0") add_money('pmview', false);
}


function myplaza_threads_open($tids)	{ handle_threads($tids, 'thread_open', false); }
function myplaza_threads_close($tids)	{ handle_threads($tids, 'thread_open', true); }

function myplaza_threads_stick($tids)	{ handle_threads($tids, 'thread_stick', false); }
function myplaza_threads_unstick($tids)	{ handle_threads($tids, 'thread_stick', true); }



function handle_threads($tids, $where, $negate)
{
	global $db;
	$query = $db->query("SELECT uid, Count(*) AS uidcount FROM ".TABLE_PREFIX."threads WHERE tid IN (".implode(",", $tids).") GROUP BY uid");
	while($t = $db->fetch_array($query))
		add_money($where, $negate, $t['uid'], $t['uidcount']);
}

/*
May be included later:
approve_posts
approve_threads
merge_posts
merge_threads
move_threads
split_posts

*/


// adds money to the current user from the various possible sources
function add_money($where, $negate, $uid = 0, $rate = 1)
{
	global $mybb;
	$amount = floatval($mybb->settings['income_money_'.$where]) * $mybb->settings['income_global_rate_income'];
	
	if($negate) $amount *= $mybb->settings['income_global_rate_income_negate'];
	
	if(!$uid)
	{
		$uid = $mybb->user['uid'];
		$user = $mybb->user;
	}
	else
	{
		$user = array('uid' => $uid);
	}
	user_change_money($user, $amount, $rate);
}


function income_settings() {
	return array(
		'income_money_post' => 10,
		'income_money_postedit' => 0.1,
		'income_money_reply' => 0.5,
		'income_money_thread' => 10,
		'income_money_poll' => 5,
		'income_money_pollvote' => 1,
		'income_money_pollparticipate' => 0.5,
		'income_money_referral' => 10,
		'income_money_referredbonus' => 5,
		'income_money_ratethread' => 0.5,
		'income_money_ratethread_base' => 1,
		'income_money_rateuser' => 2,
		'income_money_rateuser_base' => 2,
		'income_money_pmsend' => 1,
		'income_money_pmview' => 0.1,
		'income_money_attach' => 3,
		'income_money_page' => 0.01,
		'income_money_thread_open' => 1,
		'income_money_thread_stick' => 1,
		'income_global_rate_income' => 1,
		'income_global_rate_income_negate' => -1
	);
}

?>