<?php
/*
 *  This is a simple demonstration of a basic MyPlaza module.  See demo.php for a more complex
 *  example of what MyPlaza modules can do.
 *  This module will just add an item which allows a user to get +1000 in post count
 */

// this is to stop a user directly accessing this file
if(!defined("IN_MYBB"))
	die("This file cannot be accessed directly.");

// basically the same as a normal plugin
//  include this function, and specify your module's details
function simpledemo_info()
{
	return array(
		"name"			=> "Simple Demo Module",
		"description"	=> "Demo module - shows the basic structure of how to make a module for MyPlaza",
		"website"		=> "http://yourwebsite.com/",
		"author"		=> "Your name here",
		"authorsite"	=> "http://authorwebsite.com/",
		"version"		=> "1.0",
	);
}

function simpledemo_activate()
{
	// add our items
	$item = array(
		"name" => 'Add 1000 to post count',
		// a unique id for the item (not shown publically)
		//  this is used to distinguish this item from others
		"idname" => 'add1000postcount',
		"description" => 'Adds 1000 to your post count.',
		
		"cost" => 10.00,
	);
	myplaza_add_item($item, 'simpledemo'); //remember to place the name of the module here!
}

function simpledemo_deactivate()
{
	// remove all items we added earlier
	myplaza_remove_module_items('simpledemo');
}

// this function handles what is done when buying an item
function simpledemo_run($item)
{
	// just to check if the user has bought the correct item
	//  (unless something weird has happened, this should never be true)
	if($item['idname'] != 'add1000postcount')
	{
		// something wrong!  STOP!!! :P
		return false;
	}
	
	// everything seems fine, so add 1000 to the user's post count :)
	global $mybb, $db;
	$db->query("UPDATE ".TABLE_PREFIX."users
		SET postnum = postnum + 1000
		WHERE uid='".intval($mybb->user['uid'])."'");
	
	// everything successful, so return true
	return true;
}

?>